@Library('shared_lib') _
pipeline {
    agent any

    stages {
        stage("clone") {
            steps {
                git 'https://github.com/opstree/spring3hibernate'
            }
        }
        stage("stability") {
            steps {
            functions('compile')
            }
        }
        stage("quality"){
            steps{
                functions('checkstyle:checkstyle')
            }
        }
        stage("coverage"){
            steps{
                functions('cobertura:cobertura')
            }
        }
        stage("code coverage report"){
            steps{
                cobertura coberturaReportFile: '**target/site/cobertura/coverage.xml'
            }
        }
    }
    post {
        always {
            cleanWs()
            echo "workspace cleaned"
        }
        failure {
            slackSend (channel: 'slacknotify', color: '#FF0000', message: "FAILED: Job '${env.JOB_NAME} [${env.BUILD_NUMBER}]' (${env.BUILD_URL})")
            mail to: 'ravinder.singh@mygurukulam.org',
            subject: "Failed Pipeline: ${currentBuild.fullDisplayName}",
            body: "Something is wrong with ${env.BUILD_URL}"
        }
        success {
            slackSend (channel: 'slacknotify', color: '#FF0000', message: "FAILED: Job '${env.JOB_NAME} [${env.BUILD_NUMBER}]' (${env.BUILD_URL})")
            mail to: 'ravinder.singh@mygurukulam.org',
            subject: "Pipeline successful: ${currentBuild.fullDisplayName}",
            body: "This build is successful with ${env.BUILD_URL}"
        }
        
    }
}
